import java.applet.*;
import java.awt.*;
import java.net.*;
import dao_dbengine;
import dao3032.*;
import com.ms.com.Variant;

public class EX23B extends Applet
{
	Recordset recordset;
	TextArea output;
	Database db;

	public void init()
	{
		resize(500, 400);
		output = new TextArea(20, 50);
		add(output);
	}

	public void start()
	{
		OpenDatabase();
	}
		
	public void stop()
	{
		// Close the recordset and database
		recordset.Close();
		db.Close();
	}

	private boolean OpenDatabase()
	{
		URL dbURL;
		try {
			// otherwise generate it relative to the applet
			dbURL = new java.net.URL(getDocumentBase(), "sample.mdb");
		}
		catch(Exception e) {
			showStatus("Error: " + e.getMessage());
			return false;
		}

		// strip "file:/" from dbURL
		String filename = dbURL.getFile().substring(1);

		// create the database engine
		_DBEngine idbengine = dao_dbengine.create();

		// create Variants that will hold parameters that will be
		// passed to OpenDatabase
		Variant var1 = new Variant();
		Variant var2 = new Variant();
		Variant var3 = new Variant();

		// set parameters for call to OpenDatabase
		var1.putBoolean(false);
		var2.putBoolean(false);
		var3.putString("");

		// Open the database for non-exclusive access
		db = idbengine.OpenDatabase(filename, var1, var2, var3);

		// create Variants that will hold parameters that will be
		// passed to OpenDatabase
		Variant var4 = new Variant();
		Variant var5 = new Variant();

		var4.putShort(Constants.dbOpenTable);
		var5.putShort(Constants.dbEditAdd);

		// create the recordset
		recordset = db.OpenRecordset("Programmer", var4, var5);

		// give a bonus to all the Java programmers
		GiveBonuses();

		return true;
	}

	private void GiveBonuses()
	{
		// determine how many records in the recordset
		int count = recordset.getRecordCount();

		// create a variant for each column
		Variant varSalary = new Variant();
		Variant varKnowsJava = new Variant();

		// set the name of each column
		varSalary.putString("Salary");
		varKnowsJava.putString("KnowsJava");

		// position recordset at the first record
		recordset.MoveFirst();

		// loop through the recordset, displaying each record
		for(int recNum = 0; recNum < count; recNum++)
		{
			// get the fields in this recordset
			Fields fields = recordset.getFields();
			_Field fld;

			// create a Variant that will hold each the value
			// read from each column
			Variant value;

			// get the KnowsJava field
			fld = fields.getItem(varKnowsJava);
			// get its value
			value = fld.getValue();

			// if the programmer knows Java, give a good raise
			if (value.toBoolean() == true) 
			{
				// get the Salary field
				fld = fields.getItem(varSalary);
				// get its value
				value = fld.getValue();
				// store the salary
				int salary = value.toInt();
	
				// double the programmer's salary
				int newSalary = salary * 2;

				// put the recordset into edit mode
				recordset.Edit();

				// assign the new salary to the current record
				value.putInt(newSalary);
				fld.putValue(value);

				// update the recordset
				recordset.Update();

				// display the salary change
				DisplayRaise(fields, salary, newSalary);
			}
			else
				DisplayNoRaise(fields);

			recordset.MoveNext();
		}
	}

	private void DisplayRaise(Fields fields, int oldSalary, int newSalary)
	{
		String firstName = GetField(fields, "FirstName");
		String lastName  = GetField(fields, "LastName");
			
		output.appendText(firstName + " " + lastName + 
				" got a raise from " + 
				String.valueOf(oldSalary) + 
				" to " + String.valueOf(newSalary) + "\r\n");
	}

	private void DisplayNoRaise(Fields fields)
	{
		String firstName = GetField(fields, "FirstName");
		String lastName  = GetField(fields, "LastName");
		
		output.appendText(firstName + " " + lastName + 
				" didn't get a raise.\r\n");
	}

	private String GetField(Fields fields, String fldName)
	{
		// create a new Variant using fldName
		Variant var = new Variant();
		var.putString(fldName);

		// get the field
		_Field fld = fields.getItem(var);
		// get its value
		Variant	value = fld.getValue();

		return value.toString();
	}
}

