import java.applet.*;
import java.awt.*;
import java.net.*;
import dao_dbengine;
import dao3032.*;
import com.ms.com.Variant;

public class EX23E extends Applet
{
	Recordset recordset;
	TextArea output;
	Database db;

	public void init()
	{
		resize(500, 400);
		output = new TextArea(20, 50);
		add(output);
	}

	public void start()
	{
		OpenDatabase();
	}
		
	public void stop()
	{
		// Close the recordset and database
		recordset.Close();
		db.Close();
	}

	private boolean OpenDatabase()
	{
		URL dbURL;
		try {
			// otherwise generate it relative to the applet
			dbURL = new java.net.URL(getDocumentBase(), "sample.mdb");
		}
		catch(Exception e) {
			showStatus("Error: " + e.getMessage());
			return false;
		}

		// strip "file:/" from dbURL
		String filename = dbURL.getFile().substring(1);

		// create the database engine
		_DBEngine idbengine = dao_dbengine.create();

		// create Variants that will hold parameters that will be
		// passed to OpenDatabase
		Variant var1 = new Variant();
		Variant var2 = new Variant();
		Variant var3 = new Variant();

		// set parameters for call to OpenDatabase
		var1.putBoolean(false);
		var2.putBoolean(false);
		var3.putString("");

		// Open the database for non-exclusive access
		db = idbengine.OpenDatabase(filename, var1, var2, var3);

		// create Variants that will hold parameters that will be
		// passed to OpenDatabase
		Variant var4 = new Variant();
		Variant var5 = new Variant();

		var4.putShort(Constants.dbOpenDynaset);
		var5.putShort(Constants.dbEditAdd);

		// create the recordset
		recordset = db.OpenRecordset("Programmer", var4, var5);

		// give a bonus to all the Java programmers
		FindProgrammers();

		return true;
	}

	private void FindProgrammers()
	{
		// setup the search criteria
		String criteria = "Salary < 50000";

		// find the first matching record
		recordset.FindFirst(criteria);

		// while there are matching records keep going
		while (recordset.getNoMatch() == false)
		{
			// display the programmer's name
			DisplayProgrammer();

			// and search for another one
			recordset.FindNext(criteria);
		}
	}

	private void DisplayProgrammer()
	{
		// determine how many records in the recordset
		int count = recordset.getRecordCount();

		// create a variant for each column
		Variant varFirstName = new Variant();
		Variant varLastName = new Variant();
		Variant varSalary = new Variant();
		Variant varKnowsJava = new Variant();
		Variant varJobTitle = new Variant();

		// set the name of each column
		varFirstName.putString("FirstName");
		varLastName.putString("LastName");
		varSalary.putString("Salary");
		varKnowsJava.putString("KnowsJava");
		varJobTitle.putString("JobTitle");

		// get the fields in this recordset
		Fields fields = recordset.getFields();
		_Field fld;

		// create a Variant that will hold each the value
		// read from each column
		Variant value;

		// get the LastName field
		fld = fields.getItem(varLastName);
		// get its value
		value = fld.getValue();
		// display the value
		output.appendText(value.toString() + ", ");

		// get the FirstName field
		fld = fields.getItem(varFirstName);
		// get its value
		value = fld.getValue();
		// display the value
		output.appendText(value.toString() + "\r\n");

		// get the JobTitle field
		fld = fields.getItem(varJobTitle);
		// get its value
		value = fld.getValue();
		// display the value
		output.appendText("\t" + value.toString() + "\r\n");

		// get the Salary field
		fld = fields.getItem(varSalary);
		// get its value
		value = fld.getValue();
		// display the value
		output.appendText("\t" + value.toString() + "\r\n");

		// get the KnowsJava field
		fld = fields.getItem(varKnowsJava);
		// get its value
		value = fld.getValue();
		// display the value
		Boolean knowsJava = new Boolean (value.toBoolean());
		output.appendText("\tKnows Java: " + knowsJava.toString() + "\r\n");
	}
}

